;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.1 - GPL3 - Feb 2012
;
;-----------------------------------------------------------------------------------
; Initializations
;-----------------------------------------------------------------------------------

K_Init:

	; Set up RTC
	call InitRTC

	; Set PIT Channel 0 to fire at 100Hz (Divisor = 1193180 / hz)
	mov al, 0x34			; 0x34 = 00110100b
	out 0x43, al
	mov al, 0x9B			; lsb - We want 100Hz so 0x2E9B
	out 0x40, al
	mov al, 0x2E			; msb - 1.19318Mhz/11931 = 100 Hz
	out 0x40, al


	; Set keyboard repeat rate to max
	mov al, 0xf3
	out 0x60, al			; Set Typematic Rate/Delay
	xor al, al
	out 0x60, al			; 30 cps and .25 second delay
	mov al, 0xed
	out 0x60, al			; Set/Reset LEDs
	xor al, al
	out 0x60, al			; all off

	; Empty the keyboard's buffer
	xor cx, cx          		; Allow 65,536 times thru loop.
.Wait4Empty:
     	in  al, 64h         		; Read keyboard status register.
        test al, 10b         		; Input buffer full?
        loopnz .Wait4Empty      	; If so, wait until empty.

	; Disable blink
	mov dx, 0x3DA
	in al, dx
	mov dx, 0x3C0
	mov al, 0x30
	out dx, al
	add dx, 1
	in al, dx
	and al, 0xF7
	sub dx, 1
	out dx, al


	; Enable specific interrupts
	;---------------------------
	in al, 0x21
	mov al, 11111000b		; Enable Timer (0), Keyboard (1), Cascade (2)
	out 0x21, al
	in al, 0xA1
	mov al, 11111110b		; Enable RTC (8)
	out 0xA1, al

ret


; ===================================================================================================
; EOF

